declare module 'react-native-ico-font-awesome' {
    import { ReactNode } from 'react';
    import { SvgProps, AdditionalProps } from 'react-native-svg';

    type iconNames = 'add-square-button' |
      'adjust-contrast' |
      'align-justify' |
      'align-to-left' |
      'align-to-right' |
      'ambulance' |
      'anchor-shape' |
      'android-character-symbol' |
      'angle-arrow-down' |
      'angle-arrow-pointing-to-right' |
      'angle-pointing-to-left' |
      'apple-logo' |
      'archive-black-box' |
      'arrow-angle-pointing-down' |
      'arrow-down-on-black-circular-background' |
      'arrow-pointing-down' |
      'arrow-pointing-right-in-a-circle' |
      'arrow-pointing-to-left' |
      'arrow-pointing-to-right' |
      'arrow-up-on-a-black-circle-background' |
      'arrow-up' |
      'arrowhead-pointing-to-the-right' |
      'arrowhead-pointing-up-inside-a-square-box-outline' |
      'arrowheads-pointing-to-the-left' |
      'asterisk' |
      'ban-circle-symbol' |
      'bar-graph-on-a-rectangle' |
      'barcode' |
      'beaker' |
      'beer-jar-black-silhouette' |
      'bell-musical-tool' |
      'bitbucket-logotype-camera-lens-in-perspective' |
      'bitbucket-sign' |
      'bitcoin-logo' |
      'blank-file' |
      'bold-text-option' |
      'book' |
      'bookmark-black-shape' |
      'bookmark-white' |
      'branch-with-leaves-black-shape' |
      'briefcase' |
      'bug' |
      'building-front' |
      'bull-horn-announcer' |
      'bullseye' |
      'calendar-page-empty' |
      'calendar-with-spring-binder-and-date-blocks' |
      'camera-retro' |
      'caret-arrow-up' |
      'caret-down' |
      'center-text-alignment' |
      'certificate-shape' |
      'check-box-empty' |
      'check-mark' |
      'check-sign-in-a-rounded-black-square' |
      'check' |
      'checked-symbol' |
      'checkered-raised-flag' |
      'chevron-arrow-down' |
      'chevron-arrow-up' |
      'chevron-pointing-to-the-left' |
      'chevron-sign-down' |
      'chevron-sign-left' |
      'chevron-sign-to-right' |
      'chevron-up' |
      'circle-shape-outline' |
      'circle-with-an-arrow-pointing-to-left' |
      'circular-shape-silhouette' |
      'cloud-storage-download' |
      'cloud-storage-uploading-option' |
      'cocktail-glass' |
      'code-fork-symbol' |
      'code' |
      'coffee-cup-on-a-plate-black-silhouettes' |
      'cog-wheel-silhouette' |
      'collapse-window-option' |
      'comment-black-oval-bubble-shape' |
      'comment-white-oval-bubble' |
      'comments' |
      'compass-circular-variant' |
      'computer-tablet' |
      'copy-document' |
      'correct-symbol' |
      'couple-of-arrows-changing-places' |
      'credit-card' |
      'crop-symbol' |
      'cross-mark-on-a-black-circle-background' |
      'css-3-logo' |
      'cursor' |
      'cut' |
      'dashboard' |
      'delivery-truck-silhouette' |
      'desktop-monitor' |
      'dollar-symbol' |
      'dot-and-circle' |
      'double-angle-pointing-to-right' |
      'double-left-chevron' |
      'double-sided-eraser' |
      'double-strikethrough-option' |
      'down-arrow' |
      'download-symbol' |
      'download-to-storage-drive' |
      'dribbble-logo' |
      'dropbox-logo' |
      'earth-globe' |
      'edit-interface-sign' |
      'eject-symbol' |
      'envelope-of-white-paper' |
      'envelope' |
      'euro-currency-symbol' |
      'exchange-arrows' |
      'exclamation-sign' |
      'exclamation' |
      'external-link-square-with-an-arrow-in-right-diagonal' |
      'external-link-symbol' |
      'eye-open' |
      'eye-with-a-diagonal-line-interface-symbol-for-invisibility' |
      'facebook-logo-1' |
      'facebook-logo' |
      'facetime-button' |
      'fast-forward-arrows' |
      'female-silhouette' |
      'fighter-jet-silhouette' |
      'file' |
      'film-strip-with-two-photograms' |
      'filter-tool-black-shape' |
      'finger-of-a-hand-pointing-to-right-direction' |
      'fire-extinguisher' |
      'fire-symbol' |
      'flag-black-shape' |
      'flickr-website-logo-silhouette' |
      'fluffy-cloud-silhouette' |
      'folder-closed-black-shape' |
      'folder-white-shape' |
      'font-selection-editor' |
      'font-symbol-of-letter-a' |
      'fork-and-knife-silhouette' |
      'forward-button' |
      'four-black-squares' |
      'foursquare-button' |
      'frown' |
      'fullscreen-symbol' |
      'gamepad-console' |
      'gift-box' |
      'github-character' |
      'github-logo' |
      'github-sign' |
      'gittip-website-logo' |
      'google-plus-symbol-1' |
      'google-plus-symbol' |
      'great-britain-pound' |
      'group-profile-users' |
      'half-star-shape' |
      'hand-finger-pointing-down' |
      'hand-pointing-to-left-direction' |
      'hand-pointing-upward' |
      'hard-drive' |
      'heart-shape-outline' |
      'heart-shape-silhouette' |
      'home' |
      'horizontal-resize-option' |
      'hostpital-building' |
      'hotel-letter-h-sign-inside-a-black-rounded-square' |
      'html-5-logo' |
      'inbox' |
      'increase-size-option' |
      'indent-right' |
      'information-button' |
      'information-symbol' |
      'instagram-symbol' |
      'italicize-text' |
      'keyboard' |
      'left-arrow-1' |
      'left-arrow' |
      'left-indentation-option' |
      'legal-hammer' |
      'lemon' |
      'leter-a-inside-a-black-circle' |
      'letter-p-symbol' |
      'level-up' |
      'light-bulb' |
      'lightning-bolt-shadow' |
      'link-symbol' |
      'linkedin-letters' |
      'linkedin-sign' |
      'linux-logo' |
      'list-on-window' |
      'list-with-dots' |
      'list' |
      'listing-option' |
      'long-arrow-pointing-to-left' |
      'long-arrow-pointing-to-the-right' |
      'long-arrow-pointing-up' |
      'magic-wand' |
      'magnifying-glass' |
      'man' |
      'map-marker' |
      'maxcdn-website-logo' |
      'medical-kit' |
      'meh-face-emoticon' |
      'microphone-black-shape' |
      'microphone-off' |
      'minus-button' |
      'minus-sign-inside-a-black-circle' |
      'minus-sign-inside-a-black-rounded-square-shape' |
      'minus-sign-on-a-square-outline' |
      'minus-symbol' |
      'mobile-phone' |
      'moon-phase-outline' |
      'move-option' |
      'music-headphones' |
      'music-note-black-symbol' |
      'musical-bell-outline' |
      'nine-black-tiles' |
      'numbered-list' |
      'open-folder-outline' |
      'open-folder' |
      'open-laptop-computer' |
      'open-padlock-silhouette' |
      'open-wrench-tool-silhouette' |
      'padlock-unlock' |
      'padlock' |
      'paper-bill' |
      'paper-clip-outline' |
      'paper-push-pin' |
      'paste-from-clipboard' |
      'pause-symbol' |
      'pencil' |
      'photo-camera' |
      'picture' |
      'pinterest-logo' |
      'pinterest-sign' |
      'plane' |
      'plant-leaf-with-white-details' |
      'play-button' |
      'play-circle' |
      'play-sign' |
      'play-video-button' |
      'plus-black-symbol' |
      'plus-sign-in-a-black-circle' |
      'plus-symbol-in-a-rounded-black-square' |
      'power-button-off' |
      'printing-tool' |
      'puzzle-piece-silhouette' |
      'qr-code' |
      'question-mark-on-a-circular-black-background' |
      'question-sign' |
      'quote-left' |
      'reduced-volume' |
      'refresh-arrow' |
      'refresh-page-option' |
      'remove-button' |
      'remove-symbol' |
      'renren-social-network-of-china-logotype' |
      'reorder-option' |
      'reply-arrow' |
      'reply' |
      'resize-option' |
      'retweet-arrows-symbol' |
      'rewind-button' |
      'right-arrow-in-a-circle' |
      'right-chevron' |
      'right-quotation-mark' |
      'road-perspective' |
      'rounded-black-square-shape' |
      'rss-feed-button' |
      'rss-symbol' |
      'rupee-indian' |
      'save-file-option' |
      'screenshot' |
      'settings' |
      'share-option' |
      'share-post-symbol' |
      'share-symbol' |
      'shield' |
      'shopping-cart-black-shape' |
      'sign-in' |
      'sign-out-option' |
      'signal-bars' |
      'sitemap' |
      'skype-logo' |
      'small-rocket-ship-silhouette' |
      'smile' |
      'sort-arrows-couple-pointing-up-and-down' |
      'sort-by-alphabet' |
      'sort-by-attributes-interface-button-option' |
      'sort-by-attributes' |
      'sort-by-numeric-order' |
      'sort-by-order' |
      'sort-down' |
      'sort-reverse-alphabetical-order' |
      'sort-up' |
      'speech-bubbles-comment-option' |
      'spinner-of-dots' |
      'square-shape-shadow' |
      'stack-exchange-logo' |
      'stack-exchange-symbol' |
      'star-1' |
      'star-half-empty' |
      'star' |
      'step-backward' |
      'step-forward' |
      'stethoscope' |
      'strikethrough' |
      'suitcase-with-white-details' |
      'sun' |
      'superscript-text-formatting' |
      'table-grid' |
      'tag-black-shape' |
      'tags' |
      'tasks-list' |
      'telephone-handle-silhouette' |
      'telephone-symbol-button' |
      'terminal' |
      'text-file-1' |
      'text-file' |
      'text-height-adjustment' |
      'text-width' |
      'thin-arrowheads-pointing-down' |
      'three-small-square-shapes' |
      'thumb-down' |
      'thumbs-down-silhouette' |
      'thumbs-up-hand-symbol' |
      'thumbs-up' |
      'ticket' |
      'time' |
      'tint-drop' |
      'trash' |
      'trello-website-logo' |
      'trophy' |
      'tumblr-logo-1' |
      'tumblr-logo' |
      'turkish-lire-symbol' |
      'twitter-black-shape' |
      'twitter-sign' |
      'two-columns-layout' |
      'u-shaped-thick-magnet' |
      'umbrella-black-silhouette' |
      'underline-text-option' |
      'undo-arrow' |
      'unlink-symbol' |
      'up-arrow' |
      'up-chevron-button' |
      'upload-button' |
      'upload' |
      'user-md-symbol' |
      'user-shape' |
      'vertical-ellipsis' |
      'vertical-resizing-option' |
      'video-play-square-button' |
      'vimeo-square-logo' |
      'vintage-key-outline' |
      'vk-social-network-logo' |
      'volume-off' |
      'volume-up-interface-symbol' |
      'warning-sign-on-a-triangular-background' |
      'weibo-website-logo' |
      'wheelchair' |
      'white-flag-symbol' |
      'windows-logo-silhouette' |
      'x2-symbol-of-a-letter-and-a-number-subscript' |
      'xing-logo' |
      'xing-logotype' |
      'yen-symbol' |
      'youtube-logo-1' |
      'youtube-logo-2' |
      'youtube-logo' |
      'zoom-in' |
      'zoom-out';

    type iconColors = ;

    type backgroundType = 'circle' | 'rect' | 'button';

    type colorsType = Record<iconColors, string>;

    type positionType = 'top' | 'bottom' | 'right' | 'left' |
      'top_right' | 'top_left' | 'bottom_right' | 'bottom_left';

    type backgroundTypeObj = {
      type?: backgroundType;
      color?: string;
      radius?: number;
      borderRadius?: number;
    };

    type badgeTypeObj = {
      value?: number | string;
      fontSize?: string;
      position?: positionType;
      color?: string;
      colors: colorsType;
      backgroundColor?: string;
      radius?: number;
    };

    interface IconProps {
      name: iconNames;
      width?: number;
      height?: number;
      color?: string;
      colors: colorsType;
      stroke?: number;
      background?: backgroundType | backgroundTypeObj;
      badge?: number | string | badgeTypeObj;
    }

    const Icon: (props: IconProps & SvgProps & AdditionalProps) => ReactNode;

    export { iconNames };
    export default Icon;
}
